import Vue from 'vue'
import ScreenLog from './components/screen-log'

export default {
    /*
     * display error message on-screen
     * @param time: display time in seconds or -1 for permanent message
     */
    screen(message, time = -1) {
        let ComponentClass = Vue.extend(ScreenLog)
        let instance = new ComponentClass()
        let timeout = -1
        instance.$slots.default = [message]
        instance.$mount()
        instance.$on('close', () => {
            clearTimeout(timeout)
            document.querySelector('#app').removeChild(instance.$el)
        })
        document.querySelector('#app').appendChild(instance.$el)
        if (time > 0) {
            timeout = setTimeout(() => {
                if (instance.$el.parentElement) {
                    document.querySelector('#app').removeChild(instance.$el)
                }
            }, time * 1000)
        }
    }
}
