import _ from 'lodash'

const nestedSet = {
    childrenById: function(dataSource, id) {
        console.time('childrenById')
        const parent = dataSource.find((x) => x.id === id)
        console.timeEnd('childrenById')
        return dataSource.filter((x) => x.parent_id === parent.id)
    },

    childrenBySlug: function(dataSource, slug) {
        console.time('childrenBySlug')
        const parent = dataSource.find((x) => x.slug === slug)
        console.timeEnd('childrenBySlug')
        return dataSource.filter((x) => x.parent_id === parent.id)
    },

    sortNestedSet: function(dataSource) {
        console.time('sortNestedSet')
        const data = _.cloneDeep(dataSource)
        const sorted = _.orderBy(data, ['_lft'], ['asc'])

        let reminder = 0
        let parent = false
        let depth = 0

        sorted.forEach((item, index) => {
            if (sorted[index - 1] && item._rgt < sorted[index - 1]._rgt) {
                depth++
            }

            if (sorted[index - 1] && item._lft - sorted[index - 1]._rgt > 1) {
                const steps = item._lft - sorted[index - 1]._rgt
                for (let s = 1; s < steps; s++) {
                    depth--
                }
            }

            item._depth = depth
            item._children = (item._rgt - item._lft - 1) / 2

            item._parent_hidden = false

            if (item.parent_id) {
                parent = sorted.find((x) => x.id === item.parent_id)
            }

            if (parent && !parent.published) {
                item._parent_hidden = true
            }

            parent = false
        })

        sorted.forEach((item, index) => {
            item._up = true
            item._down = true

            if (item.parent_id) {
                parent = sorted.find((x) => x.id === item.parent_id)
            }

            if (parent && parent._parent_hidden) {
                item._parent_hidden = true
            }

            parent = false

            if (index === 0) {
                item._up = false
            }

            if (index === data.length - 1) {
                item._down = false
            }

            if (item.depth > reminder) {
                item._up = false
            }

            reminder = item.depth

            if (index < sorted.length - 1) {
                if (sorted[index + 1].depth < item.depth && item.depth !== 0) {
                    item._down = false
                }
            }
        })

        console.timeEnd('sortNestedSet')

        return sorted
    }
}
